package org.jeecg.modules.stm.audit.controller;

import java.util.Arrays;
import java.util.List;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.audit.entity.AuditProjectReportConfig;
import org.jeecg.modules.stm.audit.service.IAuditProjectReportConfigService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
 
 
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 报告配置
 * @Author: jeecg-boot
 * @Date:   2025-04-26
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/audit/auditProjectReportConfig")
@Slf4j
public class AuditProjectReportConfigController extends JeecgController<AuditProjectReportConfig, IAuditProjectReportConfigService> {
	@Autowired
	private IAuditProjectReportConfigService auditProjectReportConfigService;
	
	/**
	 * 分页列表查询
	 *
	 * @param auditProjectReportConfig
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "报告配置-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<AuditProjectReportConfig>> queryPageList(AuditProjectReportConfig auditProjectReportConfig,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<AuditProjectReportConfig> queryWrapper = QueryGenerator.initQueryWrapper(auditProjectReportConfig, req.getParameterMap());
		Page<AuditProjectReportConfig> page = new Page<AuditProjectReportConfig>(pageNo, pageSize);
		IPage<AuditProjectReportConfig> pageList = auditProjectReportConfigService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	 @GetMapping(value = "/listAll")
	 public Result<List<AuditProjectReportConfig>> listAll(
			 AuditProjectReportConfig auditProjectReportConfig, HttpServletRequest req) {
		 QueryWrapper<AuditProjectReportConfig> queryWrapper = QueryGenerator.initQueryWrapper(auditProjectReportConfig, req.getParameterMap());
		 List<AuditProjectReportConfig> pageList = auditProjectReportConfigService.list(queryWrapper);
		 return Result.OK(pageList);
	 }
	/**
	 * 添加
	 * @param auditProjectReportConfig
	 * @return
	 */
	@AutoLog(value = "报告配置-添加")
	  
	@RequiresPermissions("audit:audit_project_report_config:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody AuditProjectReportConfig auditProjectReportConfig) {
		auditProjectReportConfigService.save(auditProjectReportConfig);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param auditProjectReportConfig
	 * @return
	 */
	@AutoLog(value = "报告配置-编辑")
	  
	@RequiresPermissions("audit:audit_project_report_config:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody AuditProjectReportConfig auditProjectReportConfig) {
		auditProjectReportConfigService.updateById(auditProjectReportConfig);
		return Result.OK("编辑成功!");
	}

	 @RequestMapping(value = "/batchSaveOrUpdate", method = {RequestMethod.PUT,RequestMethod.POST})
	 public Result<String> batchSaveOrUpdate(@RequestBody List<AuditProjectReportConfig> list) {
		 auditProjectReportConfigService.saveBatch(list);
		 return Result.OK("保存成功！");
	 }


	 /**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "报告配置-通过id删除")
	  
	@RequiresPermissions("audit:audit_project_report_config:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		auditProjectReportConfigService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "报告配置-批量删除")
	  
	@RequiresPermissions("audit:audit_project_report_config:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.auditProjectReportConfigService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "报告配置-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<AuditProjectReportConfig> queryById(@RequestParam(name="id",required=true) String id) {
		AuditProjectReportConfig auditProjectReportConfig = auditProjectReportConfigService.getById(id);
		if(auditProjectReportConfig==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(auditProjectReportConfig);
	}

	 @GetMapping(value = "/queryByProjectId")
	 public Result<AuditProjectReportConfig> queryByProjectId(@RequestParam(name="projectId",required=true) Integer projectId) {
		 QueryWrapper<AuditProjectReportConfig> queryWrapper = new QueryWrapper<>();
		 queryWrapper.eq("project_id",projectId);
		 List<AuditProjectReportConfig>  list = auditProjectReportConfigService.list(queryWrapper);
		 if(list==null||list.size()==0) {
			 return Result.OK();
		 }
		 return Result.OK(list.get(0));
	 }

    /**
    * 导出excel
    *
    * @param request
    * @param auditProjectReportConfig
    */
    @RequiresPermissions("audit:audit_project_report_config:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, AuditProjectReportConfig auditProjectReportConfig) {
        return super.exportXls(request, auditProjectReportConfig, AuditProjectReportConfig.class, "报告配置");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("audit:audit_project_report_config:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, AuditProjectReportConfig.class);
    }

}
